import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

/**This routine returns true if the whole block is contained
in a specific rational rectangle solid that is, in turn, contained inside
in the cube of side length 2^{-17} centered at the point
representing the TBP*/

public class EliminateInsideOmega0 {

    public static boolean main(Block X) {
	for(int i=0;i<4;++i) {
	    if(inBox(i,X.B[i])==false) return false;
	}
	return true;
    }

    /**Tests whether the box B is contained in the
       jth factor of the special neighborhood of the TBP.
       We check that all the vertices are in the box,
       using the next routine.*/

    public static boolean inBox(int j,Box B) {
	GaussianInteger[] z=B.toGaussianVertices();
	for(int i=0;i<z.length;++i) {
	    if(inBox(j,z[i])==false) return false;
	}
	return true;
    }

    /**This tests whether the complex number represented
       by the Gaussian integer is contained in the jth
       factor of the special neighborhood of the TBP.
       These Gaussian integers are the box vertices
       scaled up by 2^{30}*/

    public static boolean inBox(int j,GaussianInteger z) {
	if(j==0) return inBox0(z);
	if(j==1) return inBox1(z);
	if(j==2) return inBox2(z);
	if(j==3) return inBox3(z);
	return false;
    }


    public static boolean inBox0(GaussianInteger g) {
	if(nearOne(g.x)==false) return false;
	return true;
    }

    public static boolean inBox1(GaussianInteger g) {
	if(nearZero(g.x)==false) return false;
	if(nearRootOneThird(-g.y)==false) return false;
	return true;
    }

    public static boolean inBox2(GaussianInteger g) {
	if(nearOne(-g.x)==false) return false;
	if(nearZero(g.y)==false) return false;
	return true;
    }

    public static boolean inBox3(GaussianInteger g) {
	if(nearZero(g.x)==false) return false;
	if(nearRootOneThird(g.y)==false) return false;
	return true;
    }

    
    public static boolean nearOne(long x) {
	long ONE=1073741824;   //this is 2^{30};
	long ERR=8192;        //this is 2^{30}/2^{17}=2^{13}
	if(x<ONE-ERR) return false;
	if(x>ONE+ERR) return false;
	return true;
    }

    public static boolean nearZero(long x) {
	long ERR=8192;        //this is 2^{30}/2^{17}=2^{15}
	if(x<-ERR) return false;
	if(x>+ERR) return false;
	return true;
    }

    public static boolean nearRootOneThird(long x) {
	long y0=619916940; //lower bound to sqrt(1/3) times 2^{30}.
	long y1=619933323; //upper bound to sqrt(1/3) times 2^{30}.
	if(x<y0) return false;
	if(x>y1) return false;
	return true;
    }




}
