import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.math.*;


public class ControlCanvas extends Canvas implements MouseListener {
    ControlPanel MAIN;
    ListenSquare GO,HALT;  //stop/go
    Proof PROOF;
    String[] S=new String[4];


    /*This main routine makes the window*/
     public ControlCanvas() {
	 addMouseListener(this);
	 setup();
	GO=new ListenSquare(0,120,25,20,Color.red); GO.on=1;
	HALT=new ListenSquare(25,120,35,20,Color.red); HALT.on=1;
	PROOF=new Proof();
	for(int i=0;i<4;++i) S[i]="";
     }


    /**makes the contrl panel*/
    public void setup() {
      Color[] C0={new Color(80,160,255),Color.white,Color.white,Color.black,Color.red};
      String[] MainString={"G4","G5\u266D","G6","G10\u266F\u266F","G10\u266F","test options"};
      int[] MainState={1,0,0,0,0};
      MAIN=new ControlPanel(C0,MainString,MainState,5);
      MAIN.mode=0;
    }


    /**main rendering routine for the control panel*/
   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      makeFrame(g);
      drawControls(g);
      drawMessages(g);
   }


    /*draws the background*/
    public void makeFrame(Graphics2D g) {
    g.setColor(new Color(100,0,160));
      g.fillRect(0,0,getWidth(),getHeight()); 
    }

    /**draws the control panel*/
    public void drawControls(Graphics2D g) {
       MAIN.render(g,0,0,100);
      g.setFont(new Font("Helvetica",Font.PLAIN,12));
      if(PROOF.HALT==true) { 
          GO.render(g,new Color(0,180,0));
          g.drawString("go",(int)(GO.x+5),(int)(GO.y+15));
      }
      if(PROOF.HALT==false) { 
          HALT.render(g,new Color(220,0,0));
          g.drawString("stop",(int)(HALT.x+5),(int)(HALT.y+15));
      }
    }

    /**This draws messages it gets from the main calculation*/
    public void drawMessages(Graphics2D g) {
	g.setColor(Color.white);
        g.setFont(new Font("Helvetica",Font.PLAIN,14));
	for(int i=0;i<4;++i) g.drawString(S[i],120,20+25*i);
    }


    /**run and stop the main calculation*/
     public void doRun() {
	 if(PROOF.HALT==false) return;
         PROOF=new Proof(this);
	 new Thread(PROOF).start();
    }

    public void doStop() {
	PROOF.HALT=true;
    }


    

    /**This gets the energy hybrid data*/
    public int[][] getEnergy() {
	int m=MAIN.mode;
	if(m==0) {int[][] E={{1,4},{0,0},{0,0}};return E;}
	if(m==1) {int[][] E={{1,5},{-25,1},{0,0}};return E;}
	if(m==2) {int[][] E={{1,6},{0,0},{0,0}};return E;}
	if(m==3) {int[][] E={{1,10},{28,5},{102,2}};return E;}
	if(m==4) {int[][] E={{1,10},{13,5},{68,2}};return E;}
	return null;
    }

    /**This gets the specs for the elimination step*/
    public int[] getEliminationSpecs() {
	int m=MAIN.mode;
	if(m==0) {int[] E={1,1,0,0};return E;}
	if(m==1) {int[] E={1,1,0,0};return E;}
	if(m==2) {int[] E={1,1,0,0};return E;}
	if(m==3) {int[] E={1,1,0,1};return E;}
	if(m==4) {int[] E={1,1,1,0};return E;}
	return null;
    }
    
    /**handling mouse events*/
    public void mouseClicked(MouseEvent e) { 
        MouseData J=MouseData.process(e);
        MAIN.switchMode(J.X);
	if(GO.inside(J.X)==1) doRun();
	if(HALT.inside(J.X)==1) doStop();
        repaint();
    }

    /**not used but need to be here*/
    public void mousePressed(MouseEvent e) {}
     public void mouseReleased(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   


}

