import java.math.*;

public class TestPosdom2 implements Runnable {
    Manager M;
    boolean HALT;
    int COUNT;
    double VOL;
    Poly2[] LIST00;
    Poly2[] LIST01;
    Poly2[] LIST10;
    Poly2[] LIST11;
    boolean TEST;

    public TestPosdom2() {
	HALT=true;
    }

    public TestPosdom2(Manager m) {
	this.M=m;
	HALT=true;
    }


    /**Here is the main algorithm*/

    public void run() {
	HALT=false;
	M.C.POSM.count=0;
	System.out.println("----START-------");
	Poly2[][][] P2=makePoly();
	System.out.println("polynomials computed...");
	doInitial(P2);


	while((HALT==false)&&(LIST00.length!=0)) {  
            if(LIST00.length>200) doFail();
	    ++COUNT;

	    Poly2 Q00=LIST00[LIST00.length-1];
	    Poly2 Q01=LIST01[LIST01.length-1];
	    Poly2 Q10=LIST10[LIST10.length-1];
	    Poly2 Q11=LIST11[LIST11.length-1];

	    TEST=false;
	     boolean TEST00=Q00.isPositiveDominant();
	     boolean TEST01=Q01.isNegativeDominant();
	     boolean TEST10=Q10.isPositiveDominant();
	     boolean TEST11=Q11.isNegativeDominant();
	     if(TEST00==true) TEST=true;
	     if(TEST01==true) TEST=true;
	     if(TEST10==true) TEST=true;
	     if(TEST11==true) TEST=true;

	    if(TEST==true) {
		announcePass(Q00);
                LIST00=diminish(LIST00);
                LIST01=diminish(LIST01);
                LIST10=diminish(LIST10);
                LIST11=diminish(LIST11);
		VOL=VOL+volume(Q00);
	    }
	    if(TEST==false) {
		announceFail(Q00);
                LIST00=augment(LIST00);
                LIST01=augment(LIST01);
                LIST10=augment(LIST10);
                LIST11=augment(LIST11);
	    }
	}


	doFinal();
	HALT=true;
	M.repaint();
    }


    public void announcePass(Poly2 Q) {
       BigRational[][] B={{Q.LEFTX,Q.RIGHTX},{Q.LEFTY,Q.RIGHTY}};
       M.C.POSM.accept(B,Q.c0,Q.c1);
       M.C.repaint();
    }

    public void announceFail(Poly2 Q) {
       BigRational[][] B={{Q.LEFTX,Q.RIGHTX},{Q.LEFTY,Q.RIGHTY}};
       M.C.POSM.reject(B,Q.c0,Q.c1);
       M.C.repaint();
    }

    public void doInitial(Poly2[][][] P2) {
	COUNT=0;
	VOL=0;	
	int n=P2.length;
        LIST00=new Poly2[n];
	LIST01=new Poly2[n];
	LIST10=new Poly2[n];
	LIST11=new Poly2[n];
	for(int i=0;i<P2.length;++i) {
	   LIST00[i]=P2[i][0][0];
	   LIST01[i]=P2[i][0][1];
	   LIST10[i]=P2[i][1][0];
	   LIST11[i]=P2[i][1][1];
	}
    }

    public void doFinal() {
	if(VOL>.9999999) System.out.println("----DONE-------");
	else System.out.println("****** INTERRUPTED ******");
    }

    public void doFail() {
       throw new ProofException("list longer then 20");
    }

    public static Poly2[] diminish(Poly2[] LIST1) {
	Poly2[] LIST2=new Poly2[LIST1.length-1];
	int n=LIST1.length;
	for(int i=0;i<n-1;++i) LIST2[i]=new Poly2(LIST1[i]);
	return LIST2;
    }

    public static Poly2[] augment(Poly2[] LIST1) {
	Poly2[] LIST2=new Poly2[LIST1.length+1];
	int n=LIST1.length;
	Poly2 Q=LIST1[n-1];
	for(int i=0;i<n-1;++i) LIST2[i]=new Poly2(LIST1[i]);
	int index=Q.youngestIndex();
	LIST2[n-1]=Q.subdivide1(index);
	LIST2[n-0]=Q.subdivide0(index);
	return LIST2;
    }

    public static double volume(Poly2 Q) {
	double x=1;
	for(int i=0;i<2;++i) x=x*Math.pow(.5,Q.age[i]);
	return(x);
    }



    /**generating the polynomials*/

    public Poly2[][][] makePoly() {

	int a=M.C.RANGE[0].val;
	int b=M.C.RANGE[1].val;
	int[][] r=TestPosdom1.getRange(a,b);
	int aa=r.length;
	M.C.POSM.accept(r[aa-1][0],r[aa-1][1]);
	M.C.repaint();
	Poly2[][][] P2=new Poly2[r.length][2][2];

	int k=0;
	while((HALT==false)&&(k<r.length)) {
	    System.out.println("computing "+r[k][0]+" "+r[k][1]);
	    P2[k][0][0]=TaylorSeries2.psi(r[k][0],r[k][1],0,M.C.ENG);   
	    P2[k][0][1]=TaylorSeries2.psi(r[k][0],r[k][1],1,M.C.ENG);   
	    P2[k][1][0]=TaylorSeries2.psiDiff(r[k][0],r[k][1],0,M.C.ENG); 
	    P2[k][1][1]=TaylorSeries2.psiDiff(r[k][0],r[k][1],1,M.C.ENG); 
	    ++k;
	}
	return P2;
    }

}



