
(*This file generates plots for Lemma A221 case 2 in the monograph.*)
(*Just load the file into Mathematica and you will see plots*)
(*for the coefficients and for the comparison function at *)
(*integer values of s.  You can modify the last lines*)
(*of the program to see plots at any value*)
            
Clear[G,k,r,COMBO,MATX,MATX0,EVAL1,EVAL2];          

(*Here are the basic functions*)
R0=Power[r,-s];
R1=-s Power[r,-s-1];
G[k_,r_]:=Power[4 - r r,k];

(*The special distances that arise in the TBP*)
s2=Sqrt[2];
s3=Sqrt[3];
s4=Sqrt[4];

(*Here is the quintuple*)
GAMMA0=1;
GAMMA1=G[1,r];
GAMMA2=G[2,r];
GAMMA3=G[5,r];
GAMMA4=G[10,r] + 28 G[5,r] + 102 G[2,r];

(*Here is the combo*)
C0=a0 + a1 GAMMA1 + a2 GAMMA2 + a3 GAMMA3 + a4 GAMMA4;
(*and its derivative*)
C1=D[C0,r];

(*This extracts the matrix*)
MATX0={C0//.r->s2,C0//.r->s3,C0//.r->s4,C1//.r->s2,C1//.r->s3};
EVAL0[X_]:=MATX0//.{a0->X[[1]],a1->X[[2]],a2->X[[3]],a3->X[[4]],a4->X[[5]]}
EVAL1[k_]:=(TEMP=IdentityMatrix[5];EVAL0[TEMP[[k]]]);
MATX=Table[EVAL1[k],{k,1,5}];

(*Here are the coefficients*)
MATX2=Inverse[MATX];
MATX2[[4]]=-MATX2[[4]]/Sqrt[2];
MATX2[[5]]=-MATX2[[5]]/Sqrt[3];
MATX2=Transpose[MATX2];
VEC={Power[s2,-s],Power[s3,-s],Power[s4,-s],s Power[s2,-s],s Power[s3, -s]};
COEFF=MATX2.VEC;

(*Here is the interpolation function Lambda*)
LAMBDA=COEFF[[1]] GAMMA0+ COEFF[[2]] GAMMA1 + COEFF[[3]] GAMMA2 + COEFF[[4]] GAMMA3 + COEFF[[5]] GAMMA4;

(*Here is the comparison function*)
H=1-LAMBDA/R0

(*This shows a plot of the coefficients and also a contour plot of the comparison function*)
Flatten[{Table[Plot[COEFF[[k]],{s,6,13}],{k,1,5}],Table[Plot[H//.s->k,{r,1.3,2}],{k,6,13}]}]
