import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.math.*;

public class HSlider {
    int x,y,w,h;
    double pos;
    Color[] C;
    String S;


    public HSlider(int x,int y,int w,int h,double pos,Color[] C,String S) {
	this.x=x;
	this.y=y;
	this.h=h;
	this.w=w;
	this.pos=pos;
	this.C=C;
	this.S=S; 
    }

    public void render(Graphics2D g) {
	g.setColor(C[0]);
	g.fillRect(x,y,w,h);
	g.setColor(C[1]);
        g.drawRect(x,y,w,h);
	g.setColor(C[2]);
	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(pos,y+1);
	gp.lineTo(x+1,y+1);
	gp.lineTo(x+1,y+h-1);
	gp.lineTo(pos,y+h-1);
	g.fill(gp);
        g.setColor(C[1]);    
        g.setFont(new Font("TimesRoman",Font.PLAIN,24));
	g.drawString(S,x+4,y+h-6);
    }

    public int inside(Point p) {
	int test=0;
	if((p.x>x)&&(p.x<x+w)&&(p.y>y)&&(p.y<y+h)) test=1;
	return(test);
    }

    public void modify(Point p) {
	int test=inside(p);
	if(test==1) {
	    pos=p.x;;
	}
    }

    public double getValue() {
	double d=1.0*(pos-x)/(w);
	return(d);
    }

}
