
(*The first part of this file checks that we have the formula for the potential correct*)

(*stereographic projection*)
ST[{x_,y_,z_}]:={x/(1-z),y/(1-z)}
  
  (*Inverse stereographic projection*)
IST[{x_,y_}]:={2 x/(1+x x + y y),2 y/(1+x x + y y),1-2/(1+x x + y y)}

  (*square distance*)
DIST2[v_,w_]:=(v-w).(v-w);

(*Here are the formulas directly from the definitions*)

a0=2 Power[DIST2[IST[{t,0}],IST[{-t,0}]],-s/2];
b0=4 Power[DIST2[IST[{t,0}],{0,0,1}],-s/2];
c0=4 Power[DIST2[IST[{t,0}],IST[{0,t}]],-s/2];



(*Here are the formulas listed in the paper*)

a1=2 Power[(1+t t) (1+t t)/16/t/t,s/2];
b1=4 Power[(1+t t)/4,s/2];
c1=4 Power[(1+t t)(1+t t)/8/t/t,s/2];

Print["test that the functions are the same (should be 1 on random evaluations)"];

Print[a0/a1//.{t->Random[],s->Random[]}]
Print[b0/b1//.{t->Random[],s->Random[]}]
Print[c0/c1//.{t->Random[],s->Random[]}]


      (*Here are the derivatives from the paper*)
      
a2=Factor[D[D[a1,{t,2},s]]]//.s->15;
b2=Factor[D[D[b1,{t,2}],s]]//.s->15;
c2=Factor[D[D[c1,{t,2}],s]]//.s->15;

      (*Now we want to square these with the formulas given in the paper*)
      
(*Here is the multiplicative factor from the paper*)
Equivalency[u_,v_,w_,x_]:=Power[2,u] Power[t, v] Power[1+t t,w] Power[2+t t+1/t/t,x];

      a3=Equivalency[-29,-14,10,3/2];
      a4=Simplify[-a2/a3];

      b3=Equivalency[-14,0,11/2,0];
      b4=Simplify[-b2/b3];

      c3=Equivalency[-41/2,-16,12,1/2];
      c4=Simplify[-c2/c3]


      (*Here are the functions alphastar, betastar, gammastar from the paper*)
     {a4,b4,c4}
