import java.awt.*;
import java.awt.geom.*;

/**This is the basic object for the subdivision alg.
The corners of the square are (x0,y0) and (x1,y1).
The two parameters (exponents) are s1 and s2.
We scale the coords by 65536=2^16.*/

public class Proof {
    Box[] LIST=new Box[1000];
    int count=0;
    int total=0;


    public void main() {
	boolean HALT=false;
	LIST[0]=Box.initial();
	count=1;
	long steps=0;
        long a=56320; //scales to 55/64
	long b=57344; //scales to 56/64
	Box CAGE=new Box(a,a,b,b,15*65536,16*65536);  //this is [55/64,56/64] x [15+24/512,16]

	System.out.println("start");
	
	while(HALT==false) {
	    Box B=LIST[count-1]; //last box on the list

	    boolean irr=isIrrelevant(B);
	    boolean eng=false;
	    boolean cage=false;

	    /**does the energy test if the box is not irrelevant*/
	    if(irr==false) {
		if(B.inside(CAGE)==true) cage=true;  //we eliminate boxs automatically when they are in the cage
		if(cage==false) eng=EnergyTest.main(B); //if the box is not in the cage we do the energy test
	    }

	    /**now we decide whether to eliminate or to subdivide*/
	    if(irr==true) eliminate(1);
	    if(eng==true) eliminate(2);
	    if(cage==true) eliminate(3);
	    if((cage==false)&&(irr==false)&&(eng==false)) subdivide();
	    /**decision done*/
	    
	    ++steps;
	    if(count==0) HALT=true;
	    System.out.println("steps "+steps);
	}  
        System.out.println("done");
    }

    /**We do this routine if the box passes the test*/
    
    public void eliminate(int k) {
	Box B=LIST[count-1];
	double s=.5*(B.S0+B.S1)/65536;
	--count; 
	++total;
    }


    /**We do these subdivision routines if the box fails the test*/
    
    public void subdivide() {
	Box B=LIST[count-1];
	long X=B.X1-B.X0;
	long S=B.S1-B.S0;
	if(16*X>S) subdivide1();
	else subdivide2();
    }

    /**subdivision in the space direction*/
    public void subdivide1() {
	Box B=LIST[count-1];
	LIST[count-1]=B.sub1(0,0);
	LIST[count-0]=B.sub1(1,0);
	LIST[count+1]=B.sub1(0,1);
	LIST[count+2]=B.sub1(1,1);
	count=count+3;
    }

    /**subdivision in the parameter direction*/
    public void subdivide2() {
	Box B=LIST[count-1];
	LIST[count-1]=B.sub2(1);
	LIST[count-0]=B.sub2(0);
	count=count+1;
    }

    /**end subdivision routines*/


    /*This tests whether the box is outside the
      relevant range.  All coords are scaled by 65536*/
    
    public static boolean isIrrelevant(Box B) {
	if(B.S1<=851968) return true;  //scales to 13
	if(B.S0>=986240) return true;  //scales to 15 + 25/512 = 15++
	if(B.X1<=44032) return true; //scales to 43/64
	if(B.Y1<=44032) return true; //scales to 43/64
	return false;
    }

}

